// ColorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rootfly.h"
#include "ColorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorDlg dialog


CColorDlg::CColorDlg(Controller* controller, const Settings* set_data, CWnd* pParent /*=NULL*/)
	: CDialog(CColorDlg::IDD, pParent),
    m_controller(*controller),
    m_set_data(*set_data)
{
	//{{AFX_DATA_INIT(CColorDlg)
	//}}AFX_DATA_INIT
}


void CColorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColorDlg)
	DDX_Control(pDX, IDC_EDIT_DEAD_SELECTED, m_edit_dead_selected_root_color);
	DDX_Control(pDX, IDC_EDIT_SELECTED, m_edit_selected_root_color);
	DDX_Control(pDX, IDC_EDIT_DEAD, m_edit_dead_root_color);
	DDX_Control(pDX, IDC_EDIT_LIVE, m_edit_live_root_color);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CColorDlg, CDialog)
//{{AFX_MSG_MAP(CColorDlg)
ON_BN_CLICKED(IDC_BUTTON_COLORDLG_DEFAULT_COLORS, OnButtonDefault)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorDlg message handlers

/**
 @brief Loads the root drawing colors and sets the color box equal to the loaded colors upon dialog creation
 */
BOOL CColorDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
  m_edit_live_root_color.SetColor(m_set_data.GetRootDrawingColorLive());
  m_edit_dead_root_color.SetColor(m_set_data.GetRootDrawingColorDead());
  m_edit_selected_root_color.SetColor(m_set_data.GetRootDrawingColorLiveSelected());
  m_edit_dead_selected_root_color.SetColor(m_set_data.GetRootDrawingColorDeadSelected());

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/**
 @brief Saves the root drawing colors if the user clicks 'OK' in the dialog
 */
void CColorDlg::OnOK() 
{
  m_controller.C_SetRootDrawingColor(m_edit_live_root_color.GetColor());
  m_controller.C_SetRootDrawingColorDead(m_edit_dead_root_color.GetColor());
  m_controller.C_SetRootDrawingColorSelected(m_edit_selected_root_color.GetColor());
  m_controller.C_SetRootDrawingColorDeadSelected(m_edit_dead_selected_root_color.GetColor());
  
	CDialog::OnOK();
}

void CColorDlg::OnButtonDefault()
{
  m_edit_live_root_color.SetColor(m_set_data.GetDefaultRootDrawingColorLive());
  m_edit_dead_root_color.SetColor(m_set_data.GetDefaultRootDrawingColorDead());
  m_edit_selected_root_color.SetColor(m_set_data.GetDefaultRootDrawingColorLiveSelected());
  m_edit_dead_selected_root_color.SetColor(m_set_data.GetDefaultRootDrawingColorDeadSelected());
}
