// FormatDateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rootfly.h"
#include "FormatDateDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// FormatDateDlg dialog


FormatDateDlg::FormatDateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(FormatDateDlg::IDD, pParent)
{
  m_order.push_back(MONTH);
  m_order.push_back(DAY);
  m_order.push_back(YEAR);
  m_date_separator = "/";
  m_four_year = true;
	//{{AFX_DATA_INIT(FormatDateDlg)
	//}}AFX_DATA_INIT
}


void FormatDateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(FormatDateDlg)
	DDX_Control(pDX, IDC_RADIO_DIGIT2, m_year_digit_4);
	DDX_Control(pDX, IDC_RADIO_DIGIT, m_year_digit_2);
	DDX_Control(pDX, IDC_EDIT_SEPARATOR, m_element_separator);
	DDX_Control(pDX, IDC_RADIO_YEAR3, m_year_3);
	DDX_Control(pDX, IDC_RADIO_YEAR2, m_year_2);
	DDX_Control(pDX, IDC_RADIO_YEAR1, m_year_1);
	DDX_Control(pDX, IDC_RADIO_MONTH3, m_month_3);
	DDX_Control(pDX, IDC_RADIO_MONTH2, m_month_2);
	DDX_Control(pDX, IDC_RADIO_MONTH1, m_month_1);
	DDX_Control(pDX, IDC_RADIO_DAY2, m_day_2);
	DDX_Control(pDX, IDC_RADIO_DAY3, m_day_3);
	DDX_Control(pDX, IDC_RADIO_DAY1, m_day_1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(FormatDateDlg, CDialog)
	//{{AFX_MSG_MAP(FormatDateDlg)
	ON_BN_CLICKED(IDC_RADIO_DAY1, OnRadioDay1)
	ON_BN_CLICKED(IDC_RADIO_DAY2, OnRadioDay2)
	ON_BN_CLICKED(IDC_RADIO_DAY3, OnRadioDay3)
	ON_EN_KILLFOCUS(IDC_EDIT_SEPARATOR, OnKillfocusEditSeparator)
	ON_BN_CLICKED(IDC_RADIO_DIGIT, OnRadioDigit)
	ON_BN_CLICKED(IDC_RADIO_DIGIT2, OnRadioDigit2)
	ON_BN_CLICKED(IDC_RADIO_MONTH1, OnRadioMonth1)
	ON_BN_CLICKED(IDC_RADIO_MONTH2, OnRadioMonth2)
	ON_BN_CLICKED(IDC_RADIO_MONTH3, OnRadioMonth3)
	ON_BN_CLICKED(IDC_RADIO_YEAR1, OnRadioYear1)
	ON_BN_CLICKED(IDC_RADIO_YEAR2, OnRadioYear2)
	ON_BN_CLICKED(IDC_RADIO_YEAR3, OnRadioYear3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// FormatDateDlg message handlers


BOOL FormatDateDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	// initialize 
  Initialize();
  
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// sets all options on startup
void FormatDateDlg::Initialize()
{
  // set first radio button
  if(m_order.at(0) == MONTH)
  {
    m_month_1.SetCheck(1);
  } else if(m_order.at(0) == DAY)
  {
    m_day_1.SetCheck(1);
  } else if(m_order.at(0) == YEAR)
  {
    m_year_1.SetCheck(1);
  }

  // set second radio button
  if(m_order.at(1) == MONTH)
  {
    m_month_2.SetCheck(1);
  } else if(m_order.at(1) == DAY)
  {
    m_day_2.SetCheck(1);
  } else if(m_order.at(1) == YEAR)
  {
    m_year_2.SetCheck(1);
  }

  // set third radio button
  if(m_order.at(2) == MONTH)
  {
    m_month_3.SetCheck(1);
  } else if(m_order.at(2) == DAY)
  {
    m_day_3.SetCheck(1);
  } else if(m_order.at(2) == YEAR)
  {
    m_year_3.SetCheck(1);
  }
  if(m_four_year) m_year_digit_4.SetCheck(1);
  else m_year_digit_2.SetCheck(1);
  m_element_separator.SetWindowText(m_date_separator);
  
}

void FormatDateDlg::OnOK() 
{
	if(GetFocus() == &m_element_separator)
  {
    OnKillfocusEditSeparator();
  } else
  {
    CDialog::OnOK();
  }
}

void FormatDateDlg::UpdateChecks(int type, int checked)
{
  vector<CButton*> selected;
  vector<CButton*> not_selected_1;
  vector<CButton*> not_selected_2;
  if(type == MONTH)
  {
    selected = GetVector(MONTH);
    not_selected_1 = GetVector(DAY);
    not_selected_2 = GetVector(YEAR);
  } else if(type == DAY)
  {
    selected = GetVector(DAY);
    not_selected_1 = GetVector(MONTH);
    not_selected_2 = GetVector(YEAR);
  } else if(type == YEAR)
  {
    selected = GetVector(YEAR);
    not_selected_1 = GetVector(DAY);
    not_selected_2 = GetVector(MONTH);
  }

  // first radio button wasn't the on pushed
  // but the first one was previously selected
  if(checked != 1 && selected.at(0)->GetCheck())
  {
    if(not_selected_1.at(checked-1)->GetCheck())
    {
      not_selected_1.at(checked-1)->SetCheck(0);
      not_selected_1.at(0)->SetCheck(1);
    } else if(not_selected_2.at(checked-1)->GetCheck())
    {
      not_selected_2.at(checked-1)->SetCheck(0);
      not_selected_2.at(0)->SetCheck(1);
    }
    selected.at(0)->SetCheck(0);
  }  

  // second radio button wasn't the on pushed
  // but the second one was previously selected
  if(checked != 2 && selected.at(1)->GetCheck())
  {
    if(not_selected_1.at(checked-1)->GetCheck())
    {
      not_selected_1.at(checked-1)->SetCheck(0);
      not_selected_1.at(1)->SetCheck(1);
    } else if(not_selected_2.at(checked-1)->GetCheck())
    {
      not_selected_2.at(checked-1)->SetCheck(0);
      not_selected_2.at(1)->SetCheck(1);
    }
    selected.at(1)->SetCheck(0);
  }
  
  // third radio button wasn't the on pushed
  // but the third one was previously selected
  if(checked != 3 && selected.at(2)->GetCheck())
  {
    if(not_selected_1.at(checked-1)->GetCheck())
    {
      not_selected_1.at(checked-1)->SetCheck(0);
      not_selected_1.at(2)->SetCheck(1);
    } else if(not_selected_2.at(checked-1)->GetCheck())
    {
      not_selected_2.at(checked-1)->SetCheck(0);
      not_selected_2.at(2)->SetCheck(1);
    }
    selected.at(2)->SetCheck(0);
  }
  UpdateOrder();
}

// updates the order of the elements in the format
void FormatDateDlg::UpdateOrder()
{
  int i;

  vector<CButton*> month, day, year;
  
  month = GetVector(MONTH);
  day = GetVector(DAY);
  year = GetVector(YEAR);

  // finds the correct place for the month
  for(i = 0; i < month.size(); i++)
  {
    if(month.at(i)->GetCheck())
    {
      m_order.at(i) = MONTH;
    }
  }
  // finds the correct place for the day
  for(i = 0; i < day.size(); i++)
  {
    if(day.at(i)->GetCheck())
    {
      m_order.at(i) = DAY;
    }
  }
  // finds the correct place for the year
  for(i = 0; i < year.size(); i++)
  {
    if(year.at(i)->GetCheck())
    {
      m_order.at(i) = YEAR;
    }
  }
}

vector<CButton*> FormatDateDlg::GetVector(int type)
{
  vector<CButton*> temp;
  if(type == MONTH)
  {
    temp.push_back(&m_month_1);
    temp.push_back(&m_month_2);
    temp.push_back(&m_month_3);
  } else if(type == DAY)
  {
    temp.push_back(&m_day_1);
    temp.push_back(&m_day_2);
    temp.push_back(&m_day_3);
  } else if(type == YEAR)
  {
    temp.push_back(&m_year_1);
    temp.push_back(&m_year_2);
    temp.push_back(&m_year_3);
  }
  return temp;
}

void FormatDateDlg::OnKillfocusEditSeparator() 
{
	m_element_separator.GetWindowText(m_date_separator);	
}

void FormatDateDlg::OnRadioMonth1() 
{
  UpdateChecks(MONTH,1);
}

void FormatDateDlg::OnRadioMonth2() 
{
	UpdateChecks(MONTH,2);	
}

void FormatDateDlg::OnRadioMonth3() 
{
	UpdateChecks(MONTH,3);
}

void FormatDateDlg::OnRadioDay1() 
{
	UpdateChecks(DAY,1);
}

void FormatDateDlg::OnRadioDay2() 
{
	UpdateChecks(DAY,2);	
}

void FormatDateDlg::OnRadioDay3() 
{
  UpdateChecks(DAY,3);
}

void FormatDateDlg::OnRadioYear1() 
{
	UpdateChecks(YEAR,1);	
}

void FormatDateDlg::OnRadioYear2() 
{
	UpdateChecks(YEAR,2);	
}

void FormatDateDlg::OnRadioYear3() 
{
	UpdateChecks(YEAR,3);
}

void FormatDateDlg::OnRadioDigit() 
{
  // setting the format of the year to 2 digits
	if(m_year_digit_4.GetCheck())
  {
    m_year_digit_4.SetCheck(0);
    m_four_year = false;
  }
}

void FormatDateDlg::OnRadioDigit2() 
{
  // setting the format of the year to 4 digits
	if(m_year_digit_2.GetCheck())
  {
    m_year_digit_2.SetCheck(0);
    m_four_year = true;
  }
}

Date_Format FormatDateDlg::GetDateFormat()
{
  Date_Format temp;
  temp.date_delim = m_date_separator;
  temp.order = m_order;
  temp.four_year = m_four_year;
  return temp;
}